// subor Bug.java

import swarm.Globals;
import swarm.space.Grid2d;
import swarm.space.Grid2dImpl;
import swarm.gui.Raster;
import swarm.objectbase.SwarmObjectImpl;
import swarm.defobj.Zone;

public class Bug extends SwarmObjectImpl
{
	public int xPos, yPos;
	public int xsize, ysize;
	public Grid2d world;
	public FoodSpace food;
	
	int haveEaten;
	
	public Bug(Zone aZone)
	{
		super(aZone);
	}
	
	public void setWorld$Food(Grid2d w, FoodSpace f)
	{
		world = w;
		food = f;
	}
	
	public void createEnd()
	{
		xsize = world.getSizeX();
		ysize = world.getSizeY();
	}
	
	public void setX$Y(int x, int y)
	{
		xPos = x;
		yPos = y;
	}
	
	public Object step()
	{
		int newX, newY;
		
		haveEaten = 0;
		
		newX = xPos + (int)Math.rint(2.0 * Math.random()) - 1;
		newY = yPos + (int)Math.rint(2.0 * Math.random()) - 1;
		
		newX = (newX + xsize) % xsize;
		newY = (newY + ysize) % ysize;
		
		if(world.getObjectAtX$Y(newX, newY) == null)
		{
			world.putObject$atX$Y(null, xPos, yPos);
			xPos = newX;
			yPos = newY;
			world.putObject$atX$Y(this, xPos, yPos);
		}
		
		if(food.getValueAtX$Y(xPos, yPos) == 1)
		{
			food.putValue$atX$Y(0, xPos, yPos);
			haveEaten = 1;
		}
		return this;
	}
	
	public Object drawSelfOn(Raster r)
	{
		r.drawPointX$Y$Color(xPos, yPos, (byte)2);
		return this;
	}

}

